﻿#region copyright
//<copyright>
// Copyright(C) 2012 TrackerRealm Corporation
// This file is part of the open source project - Jazz. http://jazz.codeplex.com
// 
// Jazz is open software: you can redistribute it and/or modify it 
// under the terms of the GNU Affero General Public License (AGPL) as published by 
// the Free Software Foundation, version 3 of the License.
// 
// Jazz is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty 
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
//  See the GNU Affero General Public License (AGPL) for more details.
// 
// You should have received a copy of the GNU General Public 
// License along with Jazz.  If not, see <http://www.gnu.org/licenses/>.
//
// REMOVAL OF THIS NOTICE IS VIOLATION OF THE COPYRIGHT. 
//</copyright>
#endregion
using System;
using System.Collections.Generic;
using System.Text;

namespace TrackerRealm.Jazz.Common
{
    /// <summary>
    /// Defines what can be stored in a server nexus and retrieved by a GUID 
    /// (for example Object, Class, String, ParseUnit, Audit, etc.).
    /// </summary>
    public enum jStorageType
    {
        /// <summary>
        /// An object should never be in this state.
        /// This could be caused by corrupted data.
        /// Typically indicates some error occured in the restoration of a field.
        /// </summary>
        Unknown = 0,
        /// <summary>
        /// 
        /// </summary>
        Class = 1,
        /// <summary>
        /// not used
        /// </summary>
        String = 2,
        /// <summary>
        /// not used
        /// </summary>
        Array = 3,
        /// <summary>
        /// Represents a piece of code that is compiled in one chuck.
        /// </summary>
        ParseUnit = 4,
        /// <summary>
        /// Audit information describes either certain system or user operations.
        /// </summary>
        Audit = 5,
        /// <summary>
        /// A c# workflow.
        /// </summary>
        JazzObject = 6,
        /// <summary>
        /// Can not be stored.
        /// </summary>
        LinkObject = 7

    }
}
